---
title: RTCIceCandidate.relatedAddress
slug: Web/API/RTCIceCandidate/relatedAddress
tags:
  - API
  - Address
  - IP
  - Property
  - RTCIceCandidate
  - Read-only
  - Reference
  - SDP
  - STUN
  - TURN
  - WebRTC
  - WebRTC API
  - relatedAddress
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">The <strong>{{domxref("RTCIceCandidate")}}</strong> interface's read-only <strong><code>relatedAddress</code></strong> property is a string indicating the <strong>related address</strong> of a relay or reflexive candidate.</span> If the candidate is a host candidate (that is, its {{domxref("RTCIceCandidate.ip", "ip")}} is in fact the real IP address of the remote peer), <code>relatedAddress</code> is <code>null</code>.</p>

<p>The <code>relatedAddress</code> field's value is set when the {{domxref("RTCIceCandidate.RTCIceCandidate", "RTCIceCandidate()")}} constructor is used. You can't specify the value of <code>relatedAddress</code> in the options object, but the address is automatically extracted from the {{domxref("RTCIceCandidateInit.candidate", "candidate")}} a-line, if it's formatted properly, being taken from its <code>rel-address</code> field.</p>

<p>The related address and port ({{domxref("RTCIceCandidate.relatedPort", "relatedPort")}}) are not used at all by {{Glossary("ICE")}} itself; they are provided for analysis and diagnostic purposes only, and their inclusion may be blocked by security systems, so do not rely on them having non-<code>null</code> values.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>relAddress</em> = <em>RTCIceCandidate</em>.relatedAddress;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} which contains the candidate's related address. For both peer and server reflexive candidates, the related address (and related port) are the base for that server or peer reflexive candidate. For relay candidates, the related address and port are set to the mapped address selected by the TURN server.</p>

<p>For host candidates, <code>relatedAddress</code> is <code>null</code>, meaning the field is not included in the candidate's a-line.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>The related address is included in ICE candidates despite not being used by ICE itself. <code>relatedAddress</code> can be used for diagnostic purposes; by observing the relationships between the various types of candidates and their addresses and related addresses. <code>relatedAddress</code> can also be used by Quality-of-Service (QoS) mechanisms.</p>

<p>Here's an {{Glossary("SDP")}} attribute line (a-line) describing an ICE candidate discovered by the STUN server:</p>

<pre>a=candidate:4234997325 1 udp 2043278322 192.168.0.56 6502 typ srflx raddr 192.168.2.77 rport 32768 generation 0</pre>

<p>The remote address, <code>relatedAddress</code>, is the dotted quad (for IPv4) or colon-delineated 64-bit address (for IPv6) immediately following the text <code>"raddr"</code>, or <code>"192.168.2.77"</code>.</p>

<h2 id="Example">Example</h2>

<p>In this example, the candidate's {{domxref("RTCIceCandidate.type", "type")}} is checked, and then debugging output is presented, based on the candidate type, including the candidate's {{domxref("RTCIceCandidate.ip", "ip")}} and <code>relatedAddress</code>.</p>

<pre class="brush: js">switch(candidate.type) {
  case "host":
    console.log("Host candidate's IP address is " + candidate.ip);
    break;
  case "srflx":
    console.log("Server reflexive candidate's base address is " +
        candidate.relatedAddress + "; reachable at " + candidate.ip);
    break;
  case "prflx":
    console.log("Peer reflexive candidate's base address is " +
        candidate.relatedAddress + "; reachable at " + candidate.ip);
    break;
  case "relay":
    console.log("Relay candidate's address assigned by the TURN server is " +
        candidate.relatedAddress + "; reachable at " + candidate.ip);
    break;
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#dom-rtcicecandidate-relatedaddress', 'RTCIceCandidate.relatedAddress')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCIceCandidate.relatedAddress")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Protocols">Introduction to WebRTC protocols</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Connectivity">WebRTC connectivity</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime">Lifetime of a WebRTC session</a></li>
 <li>{{domxref("RTCIceCanddiate.relatedPort")}}</li>
 <li>{{domxref("RTCIceCandidate.ip")}} and {{domxref("RTCIceCandidate.port")}}</li>
</ul>
